diff -ruN freeswan-1.9.orig/pluto/ipsec_doi.c freeswan-1.9/pluto/ipsec_doi.c
--- freeswan-1.9.orig/pluto/ipsec_doi.c	Sun Jan 28 16:03:04 2001
+++ freeswan-1.9/pluto/ipsec_doi.c	Thu May 17 11:09:08 2001
@@ -2213,8 +3435,348 @@
 
     update_iv(st);	/* finalize our Phase 1 IV */
 
+    DBG(DBG_PARSING,
+    DBG_log("finished main_inR3");
+    );
+
+    return STF_UNPEND_QUICK;
+}
+
+#ifdef OPENSSL
+/* Handle HDR*;IDir;[CERT];SIG_R from responder.
+ */
+stf_status
+main_inR3_ds(struct msg_digest *md)
+{
+    struct state *const st = md->st;
+    struct connection *c = st->st_connection;
+    u_char hash_val[MAX_DIGEST_LEN], *buf;
+    pb_stream *sig_pbs;
+    unsigned int dlen;
+    struct payload_digest *id_pld;
+    size_t hash_len = main_mode_hash(st, hash_val, FALSE, FALSE);
+    // size_t hash_len;
+    // main_mode_hash(st, hash_val, &hash_len, FALSE, FALSE);
+
+    /* input code similar to main_inI3_outR3 -- should be factored */
+
+    DBG(DBG_PARSING,
+    DBG_log("in main_inR3_ds");
+    );
+
+    /* IDir in */
+    if (!decode_peer_id(md, TRUE))
+      return STF_FAIL + INVALID_ID_INFORMATION;
+
+    switch (st->st_oakley.auth) {
+    case OAKLEY_RSA_SIG: /* check SIG_I */
+      {
+      RSA *rsa;
+      STACK_OF(X509) *peerlist;
+      X509 *recv_cert, *cert;
+      pb_stream *cert_pbs;
+      int i, success;
+
+      recv_cert = NULL;
+      /* First check to see if we have a certificate sent to us */
+      if ((md->chain[ISAKMP_NEXT_CERT] != NULL) &&
+          ((cert_pbs = &md->chain[ISAKMP_NEXT_CERT]->pbs) != NULL)) {
+        u_char *crt;
+        unsigned long len;
+
+        switch(cert_pbs->cur[0]) {
+        case CERT_TYPE_X509_SIG:
+          crt = &(cert_pbs->cur[1]);
+          len = pbs_left(cert_pbs)-1;
+          recv_cert = d2i_X509(NULL, &crt, len);
+          break;
+        default:
+              DBG(DBG_PARSING,
+                      DBG_log("Unhandled certificate encoding: %s",
+                      enum_show(&cert_names, cert_pbs->cur[0]));
+              );
+          break;
+        }
+      }
+
+      if (recv_cert) {
+        char buf[200];
+
+        X509_NAME_oneline(X509_get_subject_name(recv_cert)
+                          , buf, sizeof(buf));
+              DBG(DBG_PARSING,
+                      DBG_log("Sent certificate \"%s\"", buf);
+              );
+      }
+
+      id_pld = md->chain[ISAKMP_NEXT_ID];
+      if ((peerlist =
+           peer_cert_list((STACK_OF(XMAP) *)c->lu,
+                          EVP_PKEY_RSA, recv_cert, id_pld,
+                          (c->cert_options & CERT_OPTION_STRICT) ? TRUE : FALSE)) == NULL) {
+        log("Verification certificate(s) unavailable to check signature in Main R3");
+        return STF_FAIL + INVALID_SIGNATURE;
+      }
+
+      if (sk_X509_num(peerlist) == 0) {
+        log("Unable to get any certificate for peer in Main R3");
+        return STF_FAIL + INVALID_SIGNATURE;
+      }
+
+      if ((md->chain[ISAKMP_NEXT_SIG] == NULL) ||
+              ((sig_pbs = &md->chain[ISAKMP_NEXT_SIG]->pbs) == NULL)) {
+        log("Signature not present in Main R3");
+        return STF_FAIL + INVALID_SIGNATURE;
+      }
+      DBG(DBG_PARSING,
+              DBG_dump("Computed hash", hash_val, hash_len);
+      );
+      /* Iterate through all certificates in the peer list until */
+      /* we have one which verifies the signature, or we have no */
+      /* more certificates to verify with */
+      for(i=0, success=0, buf = NULL; ((success == 0) && (i < sk_X509_num(peerlist))); i++) {
+        rsa = X509_get_pubkey(sk_X509_value(peerlist, i))->pkey.rsa;
+        if ((buf = alloc_bytes(EVP_PKEY_size(X509_get_pubkey(sk_X509_value(peerlist, i))),
+                               "RSA decrypt sig")) != NULL) {
+          dlen = RSA_public_decrypt(pbs_left(sig_pbs), sig_pbs->cur, buf, rsa
+                                    , RSA_PKCS1_PADDING);
+              DBG(DBG_PARSING,
+                      DBG_dump("Decrypted hash", buf, (dlen > hash_len)
+                              ? hash_len : dlen);
+              );
+          if ((dlen == hash_len) && (memcmp(buf, hash_val, hash_len) == 0)) {
+                      DBG(DBG_PARSING,
+                              DBG_log("SIG_R matches computed hash");
+                      )
+            success = 1;
+            cert = X509_dup(sk_X509_value(peerlist, i));
+          } else {
+                      DBG(DBG_PARSING,
+                              DBG_log("SIG_R does not match computed hash");
+                      );
+          }
+          pfree(buf);
+          buf = NULL;
+        }
+      }
+      if (buf) pfree(buf);
+
+      if (!success) {
+        log_err();
+        DBG_cond_dump(DBG_CRYPT,
+                      "received SIG_R does not match computed value in Main R3:"
+                      , sig_pbs->cur, pbs_left(sig_pbs));
+        sk_X509_pop_free(peerlist, X509_free);
+        return STF_FAIL + INVALID_SIGNATURE;
+      } else {
+        /* We know that certificate 'cert' was used to */
+        /* sign the accurate hash which accompanied the method */
+        /* Now we have to verify that it is a valid certificate */
+        /* to be signing anything */
+              DBG(DBG_PARSING,
+                      DBG_log("Verifying certificate along path %s", c->path);
+              );
+              if (verify_certificate( cert, c->lu, c->path,
+                      (c->cert_options & CERT_OPTION_STRICT) ? TRUE : FALSE ))
+              {
+                      DBG(DBG_PARSING,
+                              DBG_log("Signing certificate is valid");
+                      );
+              } else {
+                      sk_X509_pop_free(peerlist, X509_free);
+                      return STF_FAIL + INVALID_CERTIFICATE;
+              }
+      }
+      sk_X509_pop_free(peerlist, X509_free);
+      }
+      break;
+    case OAKLEY_DSS_SIG:
+      {
+      DSA *dsa;
+      STACK_OF(X509) *peerlist;
+      X509 *recv_cert, *cert;
+      pb_stream *cert_pbs;
+      int i, success;
+
+      if (c->cert_options & CERT_OPTION_DSS_SHA)
+        main_mode_sha1(st, hash_val, &hash_len, FALSE, FALSE);
+      recv_cert = NULL;
+      /* First check to see if we have a certificate sent to us */
+      if ((md->chain[ISAKMP_NEXT_CERT] != NULL) &&
+          ((cert_pbs = &md->chain[ISAKMP_NEXT_CERT]->pbs) != NULL)) {
+        u_char *crt;
+        unsigned long len;
+
+        switch(cert_pbs->cur[0]) {
+        case CERT_TYPE_X509_SIG:
+          crt = &(cert_pbs->cur[1]);
+          len = pbs_left(cert_pbs)-1;
+          recv_cert = d2i_X509(NULL, &crt, len);
+          break;
+        default:
+              DBG(DBG_PARSING,
+                  DBG_log("Unhandled certificate encoding: %s",
+                          enum_show(&cert_names, cert_pbs->cur[0]));
+              );
+          break;
+        }
+      }
+
+      if (recv_cert) {
+        char buf[200];
+
+        X509_NAME_oneline(X509_get_subject_name(recv_cert)
+                          , buf, sizeof(buf));
+              DBG(DBG_PARSING,
+                      DBG_log("Sent certificate \"%s\"", buf);
+              );
+      }
+
+      /* We know this field is legitimate, because the */
+      /* decode_peer_id has been called before */
+      id_pld = md->chain[ISAKMP_NEXT_ID];
+
+      if ((peerlist =
+           peer_cert_list((STACK_OF(XMAP) *)c->lu,
+                          EVP_PKEY_DSA, recv_cert,
+                          id_pld,
+                          (c->cert_options & CERT_OPTION_STRICT) ? TRUE : FALSE )) == NULL) {
+        log("Verification certificate(s) unavailable to check signature in Main R3");
+        return STF_FAIL + INVALID_SIGNATURE;
+      }
+
+      if (sk_X509_num(peerlist) == 0) {
+        log("Unable to get any certificate for peer in Main R3");
+        return STF_FAIL + INVALID_SIGNATURE;
+      }
+
+      if ((md->chain[ISAKMP_NEXT_SIG] == NULL) ||
+          ((sig_pbs = &md->chain[ISAKMP_NEXT_SIG]->pbs) == NULL)) {
+        log("Signature not present in Main R3");
+        return STF_FAIL + INVALID_SIGNATURE;
+      }
+      DBG(DBG_PARSING,
+              DBG_dump("Computed hash", hash_val, hash_len);
+      );
+      /* Iterate through all certificates in the peer list until */
+      /* we have one which verifies the signature, or we have no */
+      /* more certificates to verify with */
+      for(i=0, success=0, buf=NULL; ((success == 0) && (i < sk_X509_num(peerlist))); i++) {
+        dsa = X509_get_pubkey(sk_X509_value(peerlist, i))->pkey.dsa;
+        if ((buf = alloc_bytes(SHA1_DIGEST_SIZE, "DSA decrypt sig")) != NULL) {
+          success = (c->cert_options & CERT_OPTION_DSS_ALT)
+            ? DSA_verify_raw(hash_val, hash_len,
+                             sig_pbs->cur, pbs_left(sig_pbs),
+                             dsa)
+            : DSA_verify(EVP_PKEY_DSA,
+                         hash_val, hash_len,
+                         sig_pbs->cur, pbs_left(sig_pbs),
+                         dsa);
+          if (success == 1) {
+                      DBG(DBG_PARSING,
+                              DBG_log("SIG_I matches computed hash");
+                      );
+            cert = X509_dup(sk_X509_value(peerlist, i));;
+          } else if (success == 0) {
+                      DBG(DBG_PARSING,
+                              DBG_log("SIG_I does not match computed hash");
+                      );
+          } else {
+                      DBG(DBG_PARSING,
+                    DBG_log("Verification error");
+                      );
+            log_err();
+          }
+          pfree(buf);
+          buf = NULL;
+        }
+      }
+      if (buf) pfree(buf);
+      if (!success) {
+        log_err();
+        DBG_cond_dump(DBG_CRYPT, "received SIG_I does not match computed value in Main I3:"
+                      , sig_pbs->cur, pbs_left(sig_pbs));
+        sk_X509_pop_free(peerlist, X509_free);
+        return STF_FAIL + INVALID_SIGNATURE;
+      } else {
+        /* We know that certificate 'cert' was used to */
+        /* sign the accurate hash which accompanied the method */
+        /* Now we have to verify that it is a valid certificate */
+        /* to be signing anything */
+              DBG(DBG_PARSING,
+                      DBG_log("Verifying certificate along path %s", c->path);
+              );
+        if (verify_certificate( cert, c->lu, c->path, (c->cert_options & CERT_OPTION_STRICT) ? TRUE : FALSE ))
+              {
+                      DBG(DBG_PARSING,
+                              DBG_log("Signing certificate is valid");
+                      );
+              }
+        else {
+          sk_X509_pop_free(peerlist, X509_free);
+          return STF_FAIL + INVALID_CERTIFICATE;
+        }
+      }
+      sk_X509_pop_free(peerlist, X509_free);
+      }
+      break;
+    default:
+      return STF_INTERNAL_ERROR;
+      break;
+    }
+
+    /**************** done input ****************/
+
+    /* Advance state */
+    st->st_state = STATE_MAIN_I4;
+    c->newest_isakmp_sa = st->st_serialno;
+
+    update_iv(st);    /* finalize our Phase 1 IV */
+
+    DBG(DBG_PARSING,
+    DBG_log("finished main_inR3_ds");
+    );
+
+    return STF_UNPEND_QUICK;
+}
+#endif
+
+#ifdef OPENSSL
+/* Handle HDR*;HASH_R from responder.
+ */
+stf_status
+main_inR3_pk(struct msg_digest *md)
+{
+    struct state *const st = md->st;
+    struct connection *c = st->st_connection;
+
+    /* input code similar to main_inI3_outR3 -- should be factored */
+
+    DBG(DBG_PARSING,
+    DBG_log("in main_inR3_pk");
+    );
+
+    /* HASH_R in */
+    // CHECK_HASH(main_mode_hash(st, hash_val, &hash_len, FALSE, FALSE)
+      // , "HASH_R", "Main R3");
+      RETURN_STF_FAILURE(check_main_authenticator(md, FALSE));
+
+    /**************** done input ****************/
+
+    /* Advance state */
+    st->st_state = STATE_MAIN_I4;
+    c->newest_isakmp_sa = st->st_serialno;
+
+    update_iv(st);    /* finalize our Phase 1 IV */
+
+    DBG(DBG_PARSING,
+    DBG_log("finished main_inR3_pk");
+    );
+
     return STF_UNPEND_QUICK;
 }
+#endif
+
 
 /* Handle first message of Phase 2 -- Quick Mode.
  * HDR*, HASH(1), SA, Ni [, KE ] [, IDci, IDcr ] -->
@@ -2375,22 +3937,22 @@
 
 			if (ugh != NULL)
 			{
-			    loglog(RC_OPPOFAILURE, "failure discovering gateway: %s", ugh);
-			    return STF_FAIL + INVALID_ID_INFORMATION;
-			}
-			gw = gateways;
-			if (!sameaddr(&c->that.host_addr, &gw->gw))
-			{
+                            loglog(RC_OPPOFAILURE, "failure discovering gateway: %s", ugh);
+                            return STF_FAIL + INVALID_ID_INFORMATION;
+                        }
+                        gw = gateways;
+                        if (!sameaddr(&c->that.host_addr, &gw->gw))
+                        {
 			    char fgwb[ADDRTOT_BUF]
-				, cb[ADDRTOT_BUF]
-				, rgwb[ADDRTOT_BUF];
+                               , cb[ADDRTOT_BUF]
+                               , rgwb[ADDRTOT_BUF];
 
 			    addrtot(&c->that.host_addr, 0, fgwb, sizeof(fgwb));
 			    addrtot(&peer_client, 0, cb, sizeof(cb));
-			    addrtot(&gw->gw, 0, rgwb, sizeof(rgwb));
+                            addrtot(&gw->gw, 0, rgwb, sizeof(rgwb));
 			    loglog(RC_OPPOFAILURE
-				, "gateway %s claims client %s, but client says gateway is %s"
-				, fgwb, cb, rgwb);
+                              , "gateway %s claims client %s, but client says gateway is %s"
+                              , fgwb, cb, rgwb);
 			    return STF_FAIL + INVALID_ID_INFORMATION;
 			}
 
@@ -2399,7 +3961,7 @@
 			    loglog(RC_OPPOFAILURE, "peer and client disagree about public key");
 			    return STF_FAIL + INVALID_ID_INFORMATION;
 			}
-			gw->last_worked_time = now();
+                        gw->last_worked_time = now();
 		    }
 
 		    /* Instantiate inbound Opportunism, carrying over his ID
@@ -2494,8 +4056,8 @@
 
 	compute_dh_shared(st, st->st_gi, st->st_pfs_group);
 #ifdef DODGE_DH_MISSING_ZERO_BUG
-	if (st->st_shared.ptr[0] == 0)
-	    return STF_DROP_DOOMED_EXCHANGE;
+        if (st->st_shared.ptr[0] == 0)
+            return STF_DROP_DOOMED_EXCHANGE;
 #endif
     }
 
@@ -2574,8 +4136,8 @@
     {
 	compute_dh_shared(st, st->st_gr, st->st_pfs_group);
 #ifdef DODGE_DH_MISSING_ZERO_BUG
-	if (st->st_shared.ptr[0] == 0)
-	    return STF_REPLACE_DOOMED_EXCHANGE;
+        if (st->st_shared.ptr[0] == 0)
+            return STF_DROP_DOOMED_EXCHANGE;
 #endif
     }
 
@@ -2660,8 +4222,510 @@
     if (c->gw_info != NULL)
 	c->gw_info->last_worked_time = now();
 
+    DBG(DBG_PARSING,
+    DBG_log("finished main_inI3_outR3");
+    );
+
     return STF_REPLY;
 }
+
+#ifdef OPENSSL
+/*
+ * Handle HDR*;IDii;HASH_I from initiator. Send a HDR*;IDir;HASH_R back.
+ */
+stf_status
+main_inI3_outR3_ds(struct msg_digest *md)
+{
+    struct state *const st = md->st;
+
+    struct connection *c = st->st_connection;
+    u_char hash_val[MAX_DIGEST_LEN], *buf;
+    pb_stream *sig_pbs;
+    unsigned int dlen;
+    struct payload_digest *id_pld;
+    size_t hash_len = main_mode_hash(st, hash_val, TRUE, FALSE);
+
+    DBG(DBG_PARSING,
+    DBG_log("in main_inI3_outR3_ds");
+    );
+
+    /* input code similar to main_inR3 -- should be factored */
+
+    /* IDii in */
+    if (!decode_peer_id(md, FALSE))
+    return STF_FAIL + INVALID_ID_INFORMATION;
+
+    switch (st->st_oakley.auth) {
+    case OAKLEY_RSA_SIG: /* check SIG_I */
+      {
+  RSA *rsa;
+  STACK_OF(X509) *peerlist;
+  X509 *recv_cert, *cert;
+  pb_stream *cert_pbs;
+  int i, success;
+
+  recv_cert = NULL;
+  /* First check to see if we have a certificate sent to us */
+  if ((md->chain[ISAKMP_NEXT_CERT] != NULL) &&
+      ((cert_pbs = &md->chain[ISAKMP_NEXT_CERT]->pbs) != NULL)) {
+    u_char *crt;
+    unsigned long len;
+
+    switch(cert_pbs->cur[0]) {
+    case CERT_TYPE_X509_SIG:
+      crt = &(cert_pbs->cur[1]);
+      len = pbs_left(cert_pbs)-1;
+      recv_cert = d2i_X509(NULL, &crt, len);
+      break;
+    default:
+      DBG(DBG_PARSING,
+      DBG_log("Unhandled certificate encoding: %s",
+        enum_show(&cert_names, cert_pbs->cur[0]));
+      );
+      break;
+    }
+  }
+
+  if (recv_cert) {
+    char buf[200];
+
+    X509_NAME_oneline(X509_get_subject_name(recv_cert)
+              , buf, sizeof(buf));
+    DBG(DBG_PARSING,
+    DBG_log("Received certificate \"%s\"", buf);
+    );
+  }
+
+  /* We know this field is legitimate, because the */
+  /* decode_peer_id has been called before */
+  id_pld = md->chain[ISAKMP_NEXT_ID];
+
+  if ((peerlist = peer_cert_list((STACK_OF(XMAP) *)(c->lu),
+                     EVP_PKEY_RSA,
+                     recv_cert,
+                     id_pld,
+                     (c->cert_options & CERT_OPTION_STRICT)
+                     ? TRUE : FALSE)) == NULL) {
+    log("Verification certificate(s) unavailable to check signature in Main R3");
+    return STF_FAIL + INVALID_SIGNATURE;
+  }
+
+  if (sk_X509_num(peerlist) == 0) {
+    log("Unable to get any certificate for peer in Main R3");
+    return STF_FAIL + INVALID_SIGNATURE;
+  }
+
+  if ((md->chain[ISAKMP_NEXT_SIG] == NULL) ||
+      ((sig_pbs = &md->chain[ISAKMP_NEXT_SIG]->pbs) == NULL)) {
+    log("Signature not present in Main R3");
+    return STF_FAIL + INVALID_SIGNATURE;
+  }
+  DBG(DBG_PARSING,
+  DBG_dump("Computed hash", hash_val, hash_len);
+  );
+  /* Iterate through all certificates in the peer list until */
+  /* we have one which verifies the signature, or we have no */
+  /* more certificates to verify with */
+  for (i=0, success = 0; (success == 0) && (i<sk_X509_num(peerlist)); i++) {
+    X509 *xx = sk_X509_value(peerlist, i);
+
+    rsa = X509_get_pubkey(xx)->pkey.rsa;
+    if ((buf = alloc_bytes(EVP_PKEY_size(X509_get_pubkey(xx)),
+     "RSA decrypt sig")) != NULL) {
+      dlen = RSA_public_decrypt(pbs_left(sig_pbs), sig_pbs->cur, buf,
+        rsa, RSA_PKCS1_PADDING);
+      DBG(DBG_PARSING,
+      DBG_dump("Decrypted hash", buf, (dlen > hash_len) 
+        ? hash_len : dlen);
+      );
+      if ((dlen == hash_len) && (memcmp(buf, hash_val, hash_len) == 0)) {
+        DBG(DBG_PARSING,
+        DBG_log("SIG_I matches computed hash");
+        );
+        success = 1;
+        cert = X509_dup(xx);
+      } else {
+        DBG(DBG_PARSING,
+        DBG_log("SIG_I does not computed hash");
+        );
+      }
+      pfree(buf);
+    }
+  }
+  if (!success) {
+    log_err();
+    DBG_cond_dump(DBG_CRYPT, 
+      "received SIG_I does not match computed value in Main I3:"
+      , sig_pbs->cur, pbs_left(sig_pbs));
+    sk_X509_pop_free(peerlist, X509_free);
+    return STF_FAIL + INVALID_SIGNATURE;
+  } else {
+    /* We know that certificate 'cert' was used to */
+    /* sign the accurate hash which accompanied the method */
+    /* Now we have to verify that it is a valid certificate */
+    /* to be signing anything */
+    DBG(DBG_PARSING,
+    DBG_log("Verifying certificate along path %s", c->path);
+    );
+    if (verify_certificate( cert, c->lu, c->path, 
+      (c->cert_options & CERT_OPTION_STRICT) ? TRUE : FALSE ))
+      {
+        DBG(DBG_PARSING,
+        DBG_log("Signing certificate is valid.");
+        );
+      } else {
+        DBG(DBG_PARSING,
+        DBG_log("Signing certificate NOT valid.");
+        );
+        sk_X509_pop_free(peerlist, X509_free);
+        return STF_FAIL + INVALID_CERTIFICATE;
+      }
+  }
+  sk_X509_pop_free(peerlist, X509_free);
+      }
+      break;
+    case OAKLEY_DSS_SIG:
+      {
+  DSA *dsa;
+  STACK_OF(X509) *peerlist;
+  X509 *recv_cert, *cert;
+  pb_stream *cert_pbs;
+  int i, success;
+
+  if (c->cert_options & CERT_OPTION_DSS_SHA)
+    main_mode_sha1(st, hash_val, &hash_len, TRUE, FALSE);
+  recv_cert = NULL;
+  /* First check to see if we have a certificate sent to us */
+  if ((md->chain[ISAKMP_NEXT_CERT] != NULL) &&
+      ((cert_pbs = &md->chain[ISAKMP_NEXT_CERT]->pbs) != NULL)) {
+    u_char *crt;
+    unsigned long len;
+
+    switch(cert_pbs->cur[0]) {
+    case CERT_TYPE_X509_SIG:
+      crt = &(cert_pbs->cur[1]);
+      len = pbs_left(cert_pbs)-1;
+      recv_cert = d2i_X509(NULL, &crt, len);
+      break;
+    default:
+		DBG(DBG_PARSING,
+			DBG_log("Unhandled certificate encoding: %s",
+				enum_show(&cert_names, cert_pbs->cur[0]));
+		);
+      break;
+    }
+  }
+
+  if (recv_cert) {
+    char buf[200];
+
+    X509_NAME_oneline(X509_get_subject_name(recv_cert)
+              , buf, sizeof(buf));
+    DBG(DBG_PARSING,
+    DBG_log("Received certificate \"%s\"", buf);
+    );
+  }
+
+  /* We know this field is legitimate, because the */
+  /* decode_peer_id has been called before */
+  id_pld = md->chain[ISAKMP_NEXT_ID];
+
+  if ((peerlist =
+       peer_cert_list((STACK_OF(XMAP) *)(c->lu), EVP_PKEY_DSA,
+              recv_cert, id_pld,
+              (c->cert_options & CERT_OPTION_STRICT) ? TRUE : FALSE)) == NULL) {
+    log("Verification certificate(s) unavailable to check signature in Main R3");
+    return STF_FAIL + INVALID_SIGNATURE;
+  }
+
+  if (sk_X509_num(peerlist) == 0) {
+    log("Unable to get any certificate for peer in Main R3");
+    return STF_FAIL + INVALID_SIGNATURE;
+  }
+
+  if ((md->chain[ISAKMP_NEXT_SIG] == NULL) ||
+      ((sig_pbs = &md->chain[ISAKMP_NEXT_SIG]->pbs) == NULL)) {
+    log("Signature not present in Main R3");
+    return STF_FAIL + INVALID_SIGNATURE;
+  }
+
+  DBG(DBG_PARSING,
+  DBG_dump("Computed hash", hash_val, hash_len);
+  );
+  /* Iterate through all certificates in the peer list until */
+  /* we have one which verifies the signature, or we have no */
+  /* more certificates to verify with */
+  for(i=0, success=0, buf = NULL;
+      ((success == 0) && (i < sk_X509_num(peerlist))); i++) {
+    dsa = X509_get_pubkey(sk_X509_value(peerlist, i))->pkey.dsa;
+    if ((buf = alloc_bytes(SHA1_DIGEST_SIZE, "DSA sig space")) != NULL) {
+      success = (c->cert_options & CERT_OPTION_DSS_ALT)
+        ? DSA_verify_raw(hash_val, hash_len,
+                 sig_pbs->cur, pbs_left(sig_pbs),
+                 dsa)
+        : DSA_verify(EVP_PKEY_DSA,
+             hash_val, hash_len,
+             sig_pbs->cur, pbs_left(sig_pbs),
+             dsa)
+        ;
+      if (success == 1) {
+        DBG(DBG_PARSING,
+        DBG_log("SIG_I matches computed hash");
+        );
+        cert = X509_dup(sk_X509_value(peerlist, i));
+      } else if (success == 0) {
+        DBG(DBG_PARSING,
+        DBG_log("SIG_I does not computed hash");
+        );
+      } else {
+        DBG(DBG_PARSING,
+       	DBG_log("Verification error");
+        );
+        log_err();
+      }
+      pfree(buf);
+      buf = NULL;
+    }
+  }
+  if (buf) pfree(buf);
+  if (!success) {
+    log_err();
+    DBG_cond_dump(DBG_CRYPT, "received SIG_I does not match computed value in Main I3:"
+          , sig_pbs->cur, pbs_left(sig_pbs));
+    sk_X509_pop_free(peerlist, X509_free);
+    return STF_FAIL + INVALID_SIGNATURE;
+  } else {
+    /* We know that certificate 'cert' was used to */
+    /* sign the accurate hash which accompanied the method */
+    /* Now we have to verify that it is a valid certificate */
+    /* to be signing anything */
+    DBG(DBG_PARSING,
+    DBG_log("Verifying certificate along path %s", c->path);
+    );
+    if (verify_certificate( cert, c->lu, c->path, 
+      (c->cert_options & CERT_OPTION_STRICT) ? TRUE : FALSE ))
+    {
+      DBG(DBG_PARSING,
+      DBG_log("Signing certificate is valid");
+      );
+    } else {
+      sk_X509_pop_free(peerlist, X509_free);
+      return STF_FAIL + INVALID_CERTIFICATE;
+    }
+  }
+  sk_X509_pop_free(peerlist, X509_free);
+      }
+      break;
+      /* Should never get here */
+    default:
+      return STF_INTERNAL_ERROR;
+    }
+
+    /************* build output packet HDR*;IDir;[CERT];SIG_R ******/
+    /* ??? NOTE: this is almost the same as main_inR2_outI3's code */
+
+    /* IDir out */
+    {
+  struct isakmp_ipsec_id r_id;
+  pb_stream r_id_pbs;
+  chunk_t r_id_chunk;
+
+  // r_id.isaiid_idtype = st->st_myidentity_type;
+  r_id.isaiid_idtype = st->st_connection->this.id.kind;
+  r_id.isaiid_protoid = 0;    /* ??? is this right? */
+  r_id.isaiid_port = 0;   /* ??? is this right? */
+
+  build_id_payload(&r_id, &r_id_chunk, &st->st_connection->this);
+
+  if ((c->cert_options & CERT_OPTION_SEND) == 0)
+    r_id.isaiid_np = ISAKMP_NEXT_SIG;
+  else
+    r_id.isaiid_np = ISAKMP_NEXT_CERT;
+
+  if (!out_struct(&r_id, &isakmp_ipsec_identification_desc, &md->rbody, 
+    &r_id_pbs) || !out_chunk(r_id_chunk, &r_id_pbs, "my identity"))
+      return STF_INTERNAL_ERROR;
+  close_output_pbs(&r_id_pbs);
+
+#if 0
+  /* if a permanent cast is needed, we'll need to rethink this. */
+  r_id_chunk.len = sizeof(st->st_connection->this.id.ip_addr);
+  memcpy(&(r_id_chunk.ptr), &(st->st_connection->this.id.ip_addr), r_id_chunk.len);
+ 
+  if (!out_struct(&r_id, &isakmp_ipsec_identification_desc,
+          &md->rbody, &r_id_pbs)
+      || !out_chunk(r_id_chunk, &r_id_pbs, "my identity"))
+    return STF_INTERNAL_ERROR;
+  close_output_pbs(&r_id_pbs);
+#endif
+    }
+
+    if ((c->cert_options & CERT_OPTION_SEND) != 0) {
+      /* Send the signing certificate */
+      u_char *crt, *cx;
+      unsigned long ulen;
+      /* Send the signing certificate */
+    
+      ulen = i2d_X509(c->cert, NULL);
+      ulen++;
+      if ((cx = alloc_bytes(ulen, "ASN.1 cert")) == NULL)
+  { return STF_INTERNAL_ERROR; }
+      cx[0] = (u_char)(CERT_TYPE_X509_SIG);
+      crt = &(cx[1]);
+      i2d_X509(c->cert, &crt);
+      if (!out_generic_raw(ISAKMP_NEXT_SIG, &isakmp_ipsec_certificate_desc
+             , &md->rbody, cx, ulen, "CERT_R"))
+  return STF_INTERNAL_ERROR;
+      pfree(cx);
+    }
+
+    /* SIG_R out */
+    {
+  u_char hash_val[MAX_DIGEST_LEN];
+  u_int elen;
+  bool ok;
+
+  // size_t hash_len;
+  // main_mode_hash(st, hash_val, &hash_len, FALSE, TRUE);
+  size_t hash_len = main_mode_hash(st, hash_val, FALSE, TRUE);
+
+  /* Output the signature/hash as defined by the selected Oakley transform */
+  switch (st->st_oakley.auth) {
+  case OAKLEY_RSA_SIG: /* output signed HASH_R */
+    if ((buf = alloc_bytes(EVP_PKEY_size(c->key) + 32 /* bit of slack */,
+               "RSA sig")) == NULL)
+      return STF_INTERNAL_ERROR;
+    elen = RSA_private_encrypt(hash_len, hash_val, buf,
+                   ((EVP_PKEY *)(c->key))->pkey.rsa,
+                   RSA_PKCS1_PADDING);
+    if (!out_generic_raw(ISAKMP_NEXT_NONE, &isakmp_signature_desc,
+                 &md->rbody, buf, elen, "SIG_R"))
+      return STF_INTERNAL_ERROR;
+    break;
+  case OAKLEY_DSS_SIG:
+    if (c->cert_options & CERT_OPTION_DSS_SHA)
+      main_mode_sha1(st, hash_val, &hash_len, FALSE, TRUE);
+
+    if ((buf = alloc_bytes(EVP_PKEY_size(c->key) + 32 /* bit of slack */,
+              "DSA sig")) == NULL)
+      return STF_INTERNAL_ERROR;
+    ok = (c->cert_options & CERT_OPTION_DSS_ALT)
+      ? DSA_sign_raw(hash_val, hash_len,
+             buf, &elen,
+             ((EVP_PKEY *)(c->key))->pkey.dsa)
+      : DSA_sign(EVP_PKEY_DSA, hash_val, hash_len,
+             buf, &elen,
+             ((EVP_PKEY *)(c->key))->pkey.dsa);
+    if (!ok) {
+      log_err();
+      return STF_INTERNAL_ERROR;
+    }
+    if (!out_generic_raw(ISAKMP_NEXT_NONE, &isakmp_signature_desc,
+                 &md->rbody, buf, elen, "SIG_I"))
+      return STF_INTERNAL_ERROR;
+   
+	DBG(DBG_PARSING,
+	    DBG_log("Selected auth mechanism is %s",
+			enum_show(&oakley_auth_names, st->st_oakley.auth));
+	);
+    break;
+  default:
+    return STF_INTERNAL_ERROR;
+  }
+  pfree(buf);
+    }
+
+    /* encrypt message, sans fixed part of header */
+
+    if (!encrypt_message(&md->rbody, st))
+  return STF_INTERNAL_ERROR;  /* ??? we may be partly committed */
+
+    /* Last block of Phase 1 (R3), kept for Phase 2 IV generation */
+    DBG_cond_dump(DBG_CRYPT, "last encrypted block of Phase 1:"
+  , st->st_new_iv, st->st_new_iv_len);
+
+    /* Advance state */
+    st->st_state = STATE_MAIN_R3;
+    st->st_connection->newest_isakmp_sa = st->st_serialno;
+
+    DBG(DBG_PARSING,
+    DBG_log("finished main_inI3_outR3_ds");
+    );
+
+    return STF_REPLY;
+}
+#endif /* OPENSSL */
+
+#ifdef OPENSSL
+/*
+ * Handle HDR*;HASH_I from initiator. Send a HDR*;HASH_R back.
+ */
+stf_status
+main_inI3_outR3_pk(struct msg_digest *md)
+{
+    struct state *const st = md->st;
+
+    /* input code similar to main_inR3 -- should be factored */
+
+    DBG(DBG_PARSING,
+    DBG_log("in main_inI3_outR3_pk");
+    );
+
+    /* HASH_I in */
+    // CHECK_HASH(main_mode_hash(st, hash_val, &hash_len, TRUE, FALSE)
+  	// , "HASH_I", "Main I3");
+	RETURN_STF_FAILURE(check_main_authenticator(md, TRUE));
+
+    /**************** build output packet HDR*;HASH_R ****************/
+
+    /* HASH_R out */
+    {
+  u_char hash_val[MAX_DIGEST_LEN];
+  
+  // size_t hash_len;
+  // main_mode_hash(st, hash_val, &hash_len, FALSE, TRUE);
+  size_t hash_len = main_mode_hash(st, hash_val, FALSE, TRUE);
+
+  if (!out_generic_raw(ISAKMP_NEXT_NONE, &isakmp_hash_desc, &md->rbody
+  , hash_val, hash_len, "HASH_R"))
+      return STF_INTERNAL_ERROR;
+    }
+   
+    /* encrypt message, sans fixed part of header */
+    if (!encrypt_message(&md->rbody, st))
+  return STF_INTERNAL_ERROR;  /* ??? we may be partly committed */
+
+    /* Last block of Phase 1 (R3), kept for Phase 2 IV generation */
+    DBG_cond_dump(DBG_CRYPT, "last encrypted block of Phase 1:"
+  , st->st_new_iv, st->st_new_iv_len);
+
+    /* Advance state */
+    st->st_state = STATE_MAIN_R3;
+    st->st_connection->newest_isakmp_sa = st->st_serialno;
+
+    DBG(DBG_PARSING,
+    DBG_log("finished main_inI3_outR3_pk");
+    );
+
+    return STF_REPLY;
+}
+#endif
+
+#ifdef OPENSSL
+/* STATE_MAIN_I3:
+ * Handle HDR*;IDir;HASH/SIG_R from responder.
+ */
+stf_status
+main_inR3_whichds(struct msg_digest *md)
+{
+	if (!use_openssl(md->st->st_connection)) {
+		return main_inR3(md);
+	} else {
+		return main_inR3_ds(md);
+	}
+}
+#endif /* OPENSSL */
+
 
 /* Handle last message of Quick Mode.
  * HDR*, HASH(3) -> done
diff -ruN freeswan-1.9.orig/pluto/ipsec_doi.h freeswan-1.9/pluto/ipsec_doi.h
--- freeswan-1.9.orig/pluto/ipsec_doi.h	Tue Jun 20 22:27:28 2000
+++ freeswan-1.9/pluto/ipsec_doi.h	Wed May 16 10:57:20 2001
@@ -11,11 +11,11 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: ipsec_doi.h,v 1.22 2000/06/21 02:27:28 dhr Exp $
+ * RCSID $Id: ipsec_doi.h,v 1.23 2001/05/08 05:37:22 dhr Exp $
  */
 
 extern void ipsecdoi_initiate(int whack_sock, struct connection *c
-    , bool pending_quick, lset_t policy, unsigned long try);
+    ,bool pending_quick, lset_t policy, unsigned long try);
 
 extern void ipsecdoi_replace(struct state *st, unsigned long try);
 
@@ -28,9 +28,27 @@
     main_inI1_outR1,
     main_inR1_outI2,
     main_inI2_outR2,
+#ifdef OPENSSL
+    main_inI2_outR2_pk,
+    main_inI2_outR2_rpk,
+#endif
     main_inR2_outI3,
+#ifdef OPENSSL
+    main_inR2_outI3_pk,
+    main_inR2_outI3_rpk,
+#endif
     main_inI3_outR3,
+#ifdef OPENSSL
+    main_inI3_outR3_whichds,
+    main_inI3_outR3_ds,
+    main_inI3_outR3_pk,
+#endif
     main_inR3,
+#ifdef OPENSSL
+    main_inR3_whichds,
+    main_inR3_ds,
+    main_inR3_pk,
+#endif
     quick_inI1_outR1,
     quick_inR1_outI2,
     quick_inI2;
diff -ruN freeswan-1.9.orig/pluto/kernel.c freeswan-1.9/pluto/kernel.c
--- freeswan-1.9.orig/pluto/kernel.c	Mon Jan 29 01:20:43 2001
+++ freeswan-1.9/pluto/kernel.c	Wed May 16 10:57:20 2001
@@ -49,6 +49,7 @@
 #include "server.h"
 #include "whack.h"	/* for RC_LOG_SERIOUS */
 
+extern int send_delete(struct state *st, ipsec_spi_t *spi, bool ESP);
 
 bool can_do_IPcomp = TRUE;  /* can system actually perform IPCOMP? */
 
@@ -1569,6 +1570,8 @@
     {
 	passert(FALSE);	/* neither AH nor ESP in outbound SA bundle! */
     }
+
+    send_delete(st, &f->our_spi, proto==SA_ESP?TRUE:FALSE);
 
     return inbound
 	? del_spi(f->our_spi, proto, &c->that.host_addr, &c->this.host_addr)
